/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Icon } from "igniteui-react-inputs";
import { BaseDOMEventProxy } from "igniteui-react-core";
import { ExpansionPanelUtilities } from "./ExpansionPanelUtilities";
import { BrushUtil } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ExpansionPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(ExpansionPanelView, _super);
    function ExpansionPanelView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = null;
        _this.p = null;
        _this.g = null;
        _this.f = null;
        _this.o = null;
        _this.k = null;
        _this.n = null;
        _this.m = null;
        _this.l = null;
        return _this;
    }
    Object.defineProperty(ExpansionPanelView.prototype, "q", {
        get: function () {
            return this.p;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanelView.prototype, "h", {
        get: function () {
            return this.g;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanelView.prototype, "j", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    ExpansionPanelView.prototype.aa = function () {
        this.q.setStyleProperty("display", "flex");
        this.q.setStyleProperty("flexDirection", "column");
        this.q.setStyleProperty("flexWrap", "no-wrap");
        this.q.setStyleProperty("alignItems", "left");
    };
    ExpansionPanelView.prototype.ai = function () {
        var a = this.h;
        var b = ElevationHelper.e(a.r, a.bo, a.bn, a.bj);
        this.q.setStyleProperty("box-shadow", b);
    };
    ExpansionPanelView.prototype.aj = function () {
        if (null == this.q) {
            return;
        }
        this.ai();
        this.ag();
        this.ah();
        this.af();
        if (null != this.o) {
            NativeUI.j(this.o, this.h.bm);
        }
        if (null != this.k) {
            NativeUI.n(this.k, this.h.bk);
        }
        if (null != this.n) {
            NativeUI.n(this.n, this.h.bl);
        }
    };
    ExpansionPanelView.prototype.a = function (a) {
        return new AnimationKeyFrameEffect(0, this.k, 0, null, a);
    };
    ExpansionPanelView.prototype.b = function (a) {
        return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
    };
    ExpansionPanelView.prototype.c = function (a) {
        return new AnimationKeyFrameEffect(0, this.o, 0, null, a);
    };
    ExpansionPanelView.prototype.d = function (a) {
        return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
    };
    ExpansionPanelView.prototype.e = function (a) {
        return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
    };
    ExpansionPanelView.prototype.u = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.j;
        }
    };
    ExpansionPanelView.prototype.r = function () {
        return this.l.outerHeight();
    };
    ExpansionPanelView.prototype.ab = function (a) {
        if (a == null) {
            this.i = null;
            return;
        }
        this.i = a;
        var b = a.rootWrapper;
        this.x(b);
    };
    ExpansionPanelView.prototype.af = function () {
        if (null == this.f) {
            return;
        }
        var a = this.h.o;
        if (a) {
            this.f.svgPath = ExpansionPanelView.s;
        }
        else {
            this.f.svgPath = ExpansionPanelView.t;
        }
    };
    ExpansionPanelView.prototype.ag = function () {
        if (null != this.k) {
            var a = this.h.ac;
            this.k.setRawText(a);
        }
    };
    ExpansionPanelView.prototype.ah = function () {
        if (null != this.n) {
            var a = this.h.ai;
            this.n.setRawText(a);
        }
    };
    ExpansionPanelView.prototype.x = function (a) {
        this.p = a;
        this.aa();
    };
    ExpansionPanelView.prototype.y = function (a) {
        this.g = a;
    };
    ExpansionPanelView.prototype.z = function () {
    };
    ExpansionPanelView.prototype.ae = function (a) {
        var b = this.j;
        this.o = a;
        var c = b.createElement("div");
        this.o.append(c);
        var d = b.createElement("div");
        d.setStyleProperty("display", "inline-block");
        d.setStyleProperty("vertical-align", "middle-block");
        var e = this.i.getSubRenderer(d);
        this.f = this.h.d();
        this.f.provideContainer(e);
        this.f.bw = ExpansionPanelView.ak;
        c.append(d);
        var f = b.createElement("div");
        f.setStyleProperty("display", "flex");
        f.setStyleProperty("flex-direction", "column");
        f.setStyleProperty("justify-content", "space-evenly");
        f.setStyleProperty("align-items", "flex-start");
        this.o.append(f);
        var g = b.createElement("div");
        f.append(g);
        this.k = b.createElement("label");
        g.append(this.k);
        var h = b.createElement("div");
        f.append(h);
        this.n = b.createElement("label");
        h.append(this.n);
        this.o.setAttribute("tabindex", "0");
        this.o.setStyleProperty("display", "flex");
        this.o.setStyleProperty("flex-direction", "row");
        c.setStyleProperty("display", "flex");
        c.setStyleProperty("justify-content", "center");
        c.setStyleProperty("flex-direction", "column");
        c.setStyleProperty("margin", "0px 10px 0px 10px");
        c.setStyleProperty("flex", "none | 0 | content");
        this.aj();
        this.o.listen("click", runOn(this, this.v));
        this.o.listen("keydown", runOn(this, this.w));
    };
    ExpansionPanelView.prototype.ad = function (a) {
        var b = this.j;
        this.m = a;
        this.m.setAttribute("tabindex", "1");
        this.m.setStyleProperty("overflow", "hidden");
    };
    ExpansionPanelView.prototype.ac = function (a) {
        var b = this.j;
        this.l = a;
    };
    ExpansionPanelView.prototype.v = function (a) {
        var b = a.originalEvent;
        var c = b.target;
        this.h.a3();
    };
    ExpansionPanelView.prototype.w = function (a) {
        var b = BaseDOMEventProxy.ct(a);
        var c = ExpansionPanelUtilities.c(a);
        switch (b) {
            case 9:
            case 3:
                this.h.a3();
                a.preventDefault();
                break;
            case 17:
                if (c == 1) {
                    this.h.av();
                    a.preventDefault();
                }
                break;
            case 15:
                if (c == 1) {
                    this.h.as();
                    a.preventDefault();
                }
                break;
        }
    };
    ExpansionPanelView.$t = markType(ExpansionPanelView, 'ExpansionPanelView');
    ExpansionPanelView.ak = BrushUtil.g(255, 33, 150, 243);
    ExpansionPanelView.t = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ExpansionPanelView.s = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ExpansionPanelView;
}(Base));
export { ExpansionPanelView };
/**
 * @hidden
 */
var ExpansionPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(ExpansionPanel, _super);
    function ExpansionPanel() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.onCollapsed = null;
        _this.onExpanded = null;
        _this.propertyChanged = null;
        _this.h = null;
        _this.ab = "Caption";
        _this.bc = null;
        _this.a5 = ExpansionPanel.bt;
        _this.ba = null;
        _this.bb = null;
        _this.ah = stringEmpty();
        _this.bf = null;
        _this.a6 = ExpansionPanel.bu;
        _this.bd = null;
        _this.be = null;
        _this.q = -1;
        _this.p = ExpansionPanel.s;
        _this.n = true;
        _this.bg = null;
        _this.a7 = ExpansionPanel.bv;
        _this.bh = null;
        _this.bi = null;
        _this.a9 = ExpansionPanel.bx;
        _this.a8 = ExpansionPanel.bw;
        _this.a4 = ExpansionPanel.bs;
        var a = _this.g();
        _this.h = a;
        a.y(_this);
        return _this;
    }
    ExpansionPanel.prototype.ax = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.ay(a, b, c);
    };
    Object.defineProperty(ExpansionPanel.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            if (a == this.ab) {
                return;
            }
            var b = this.ab;
            this.ab = a;
            this.ax("Caption", b, this.ab);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "br", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.ax("CaptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bk", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.ax("ActualCaptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bp", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.ax("CaptionCollapsedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bq", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.ax("CaptionExpandedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            if (a == this.ah) {
                return;
            }
            var b = this.ah;
            this.ah = a;
            this.ax("Description", b, this.ah);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b0", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.ax("DescriptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bl", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.ax("ActualDescriptionTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "by", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.ax("DescriptionCollapsedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bz", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.ax("DescriptionExpandedTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "t", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ax("Elevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "r", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ax("ActualElevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "o", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var _this = this;
            if (a == this.n) {
                return;
            }
            this.au();
            var b = this.n;
            this.n = a;
            var c = this.i(this.n);
            var d = this.j(this.n);
            var e = this.k(this.n);
            var f = this.l(this.n);
            var g = this.m(this.n);
            c.play();
            d.play();
            e.play();
            f.play();
            g.play();
            c.finished.f(function (h) { return c.commitStyles(); });
            d.finished.f(function (h) { return d.commitStyles(); });
            e.finished.f(function (h) { return e.commitStyles(); });
            f.finished.f(function (h) { return f.commitStyles(); });
            g.finished.f(function (h) {
                g.commitStyles();
                _this.ax("Expanded", b, _this.n);
                if (_this.n) {
                    if (_this.onExpanded != null) {
                        _this.onExpanded(_this, new OnExpandedEventArgs());
                    }
                    else if (_this.onCollapsed != null) {
                        _this.onCollapsed(_this, new OnCollapsedEventArgs());
                    }
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b7", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.ax("HeaderBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bm", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.ax("ActualHeaderBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b8", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            var b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.ax("HeaderCollapsedBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "b9", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.ax("HeaderExpandedBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bo", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.ax("ActualUmbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bn", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.ax("ActualPenumbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExpansionPanel.prototype, "bj", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.ax("ActualAmbientShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    ExpansionPanel.prototype.g = function () {
        return new ExpansionPanelView();
    };
    ExpansionPanel.prototype.ay = function (a, b, c) {
        switch (a) {
            case "CaptionTextColor":
            case "CaptionExpandedTextColor":
            case "CaptionCollapsedTextColor":
            case "DescriptionTextColor":
            case "DescriptionExpandedTextColor":
            case "DescriptionCollapsedTextColor":
            case "HeaderBackgroundColor":
            case "HeaderCollapsedBackgroundColor":
            case "HeaderExpandedBackgroundColor":
            case "Expanded":
                var d = this.bm;
                var e = this.b5();
                var f = this.bk;
                var g = this.b1();
                var h = this.bl;
                var i = this.b3();
                var j = (d != e) || (f != g) || (h != i);
                if (j) {
                    this.bm = e;
                    this.bk = g;
                    this.bl = i;
                }
                else if (a == "Expanded") {
                    this.h.aj();
                }
                break;
            case "Elevation":
                this.r = this.t == -1 ? ExpansionPanel.s : this.t;
                break;
            case "ActualElevation":
            case "ActualHeaderBackgroundColor":
            case "ActualCaptionTextColor":
            case "ActualDescriptionTextColor":
            case "ActualUmbraShadowColor":
            case "ActualPenumbraShadowColor":
            case "ActualAmbientShadowColor":
            case "Caption":
            case "Description":
                this.h.aj();
                break;
        }
    };
    ExpansionPanel.prototype.i = function (a) {
        var b = this.bk;
        var c = this.b2(a);
        var d = a ? this.b() : this.a();
        var e = this.h.a(d);
        var f = [new AnimationKeyFrameProperty(7, b)];
        var g = [new AnimationKeyFrameProperty(7, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.j = function (a) {
        var b = this.bl;
        var c = this.b4(a);
        var d = a ? this.b() : this.a();
        var e = this.h.b(d);
        var f = [new AnimationKeyFrameProperty(7, b)];
        var g = [new AnimationKeyFrameProperty(7, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.k = function (a) {
        var b = this.bm;
        var c = this.b6(a);
        var d = a ? this.b() : this.a();
        var e = this.h.c(d);
        var f = [new AnimationKeyFrameProperty(2, b)];
        var g = [new AnimationKeyFrameProperty(2, c)];
        e.m.apply(e, tslib_1.__spread(f));
        e.m.apply(e, tslib_1.__spread(g));
        return KeyFrameAnimationFactory.f.c(e);
    };
    ExpansionPanel.prototype.l = function (a) {
        var b = this.h.r();
        if (b <= 0) {
            b = 500;
        }
        var c = a ? -b : 0;
        var d = a ? 0 : -b;
        var e = a ? 0 : 1;
        var f = a ? 1 : 0;
        var g = a ? this.b() : this.a();
        var h = new TranslateTransform();
        h.k = c;
        var i = new TranslateTransform();
        i.k = d;
        var j = this.h.d(g);
        var k = [new AnimationKeyFrameProperty(14, h), new AnimationKeyFrameProperty(1, e)];
        var l = [new AnimationKeyFrameProperty(14, i), new AnimationKeyFrameProperty(1, f)];
        j.m.apply(j, tslib_1.__spread(k));
        j.m.apply(j, tslib_1.__spread(l));
        return KeyFrameAnimationFactory.f.c(j);
    };
    ExpansionPanel.prototype.m = function (a) {
        var b = this.h.r();
        if (b <= 0) {
            b = 500;
        }
        var c = a ? 0 : b;
        var d = a ? b : 0;
        var e = a ? this.b() : this.a();
        var f = this.h.e(e);
        var g = [new AnimationKeyFrameProperty(10, c)];
        var h = [new AnimationKeyFrameProperty(10, d)];
        f.m.apply(f, tslib_1.__spread(g));
        f.m.apply(f, tslib_1.__spread(h));
        return KeyFrameAnimationFactory.f.c(f);
    };
    ExpansionPanel.prototype.a = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = 300;
        a.b = 3;
        return a;
    };
    ExpansionPanel.prototype.b = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = 300;
        a.b = 3;
        return a;
    };
    ExpansionPanel.prototype.au = function () {
        this.h.u();
    };
    ExpansionPanel.prototype.d = function () {
        if (null == this.c) {
            this.c = new Icon();
        }
        return this.c;
    };
    ExpansionPanel.prototype.b1 = function () {
        return this.b2(this.o);
    };
    ExpansionPanel.prototype.b2 = function (a) {
        var b;
        var c = null;
        c = a ? this.bq : this.bp;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.br ? this.br : ExpansionPanel.bt;
        }
        return b;
    };
    ExpansionPanel.prototype.b3 = function () {
        return this.b4(this.o);
    };
    ExpansionPanel.prototype.b4 = function (a) {
        var b;
        var c = null;
        c = a ? this.bz : this.by;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.b0 ? this.b0 : ExpansionPanel.bu;
        }
        return b;
    };
    ExpansionPanel.prototype.b5 = function () {
        return this.b6(this.o);
    };
    ExpansionPanel.prototype.b6 = function (a) {
        var b;
        var c = null;
        c = a ? this.b9 : this.b8;
        if (null != c) {
            b = c;
        }
        else {
            b = null != this.b7 ? this.b7 : ExpansionPanel.bv;
        }
        return b;
    };
    ExpansionPanel.prototype.as = function () {
        this.o = false;
    };
    ExpansionPanel.prototype.destroy = function () {
        this.provideRenderer(null);
    };
    ExpansionPanel.prototype.av = function () {
        this.o = true;
    };
    ExpansionPanel.prototype.notifySizeChanged = function () {
    };
    ExpansionPanel.prototype.provideHeader = function (a) {
        this.h.ae(a);
    };
    ExpansionPanel.prototype.provideContentAreaOuter = function (a) {
        this.h.ad(a);
    };
    ExpansionPanel.prototype.provideContentAreaInner = function (a) {
        this.h.ac(a);
    };
    ExpansionPanel.prototype.provideRenderer = function (a) {
        this.h.ab(a);
    };
    ExpansionPanel.prototype.a3 = function () {
        this.o = !this.o;
    };
    ExpansionPanel.$t = markType(ExpansionPanel, 'ExpansionPanel', Base.$, [INotifyPropertyChanged_$type]);
    ExpansionPanel.bt = BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.bu = BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.s = 2;
    ExpansionPanel.bv = BrushUtil.g(255, 245, 245, 245);
    ExpansionPanel.bx = BrushUtil.g(66, 0, 0, 0);
    ExpansionPanel.bw = BrushUtil.g(30, 0, 0, 0);
    ExpansionPanel.bs = BrushUtil.g(20, 0, 0, 0);
    return ExpansionPanel;
}(Base));
export { ExpansionPanel };
//# sourceMappingURL=ExpansionPanelView_combined.js.map
