import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomWrapper, DomRenderer } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Icon } from "igniteui-react-inputs";
import { Brush } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
/**
 * @hidden
 */
export declare class ExpansionPanelView extends Base {
    static $t: Type;
    private i;
    private p;
    private g;
    private f;
    private o;
    private k;
    private n;
    private m;
    private l;
    private static readonly ak;
    private static readonly t;
    private static readonly s;
    protected readonly q: DomWrapper;
    protected readonly h: ExpansionPanel;
    protected readonly j: DomRenderer;
    protected aa(): void;
    ai(): void;
    aj(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    c(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    d(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    e(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    u(): void;
    r(): number;
    ab(a: DomRenderer): void;
    private af;
    private ag;
    private ah;
    protected x(a: DomWrapper): void;
    y(a: ExpansionPanel): void;
    z(): void;
    ae(a: any): void;
    ad(a: any): void;
    ac(a: any): void;
    private v;
    private w;
}
/**
 * @hidden
 */
export declare class ExpansionPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private c;
    constructor();
    onCollapsed: (sender: any, args: OnCollapsedEventArgs) => void;
    onExpanded: (sender: any, args: OnExpandedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected ax(a: string, b: any, c: any): void;
    h: ExpansionPanelView;
    private ab;
    ac: string;
    private bc;
    br: Brush;
    private static bt;
    private a5;
    bk: Brush;
    private ba;
    bp: Brush;
    private bb;
    bq: Brush;
    private ah;
    ai: string;
    private bf;
    b0: Brush;
    private static bu;
    private a6;
    bl: Brush;
    private bd;
    by: Brush;
    private be;
    bz: Brush;
    private q;
    t: number;
    private static s;
    private p;
    r: number;
    private n;
    o: boolean;
    private bg;
    b7: Brush;
    private static bv;
    private a7;
    bm: Brush;
    private bh;
    b8: Brush;
    private bi;
    b9: Brush;
    private static bx;
    private a9;
    bo: Brush;
    private static bw;
    private a8;
    bn: Brush;
    private static bs;
    private a4;
    bj: Brush;
    protected g(): ExpansionPanelView;
    protected ay(a: string, b: any, c: any): void;
    private i;
    private j;
    private k;
    private l;
    private m;
    private a;
    private b;
    private au;
    d(): Icon;
    private b1;
    private b2;
    private b3;
    private b4;
    private b5;
    private b6;
    as(): void;
    destroy(): void;
    av(): void;
    notifySizeChanged(): void;
    provideHeader(a: any): void;
    provideContentAreaOuter(a: any): void;
    provideContentAreaInner(a: any): void;
    provideRenderer(a: DomRenderer): void;
    a3(): void;
}
